int carX;
int carSpeed;
int distance;
int speedOffset;
int oldOffset;

void race_loop()
{
  speedOffset=0;
  if (!(PINC & 0x02)) carX--;  // PORT C pin 1 is attached to left button
  if (!(PINC & 0x10)) carX++;  // PORT C pin 4 is attached to right button
  if (!(PINC & 0x04)) speedOffset=-5;
  if (!(PINC & 0x08)) speedOffset=+5;
  if (speedOffset != oldOffset) {
     oldOffset=speedOffset;
  }
  tone(speakerPin,120+(20*speedOffset)+random(5+speedOffset));

  if (frame4.GetPoint(carX,gameMaxY-2)) {
    // HIT!
    noTone(speakerPin);
    display_gameover();
    display_score();
    race_setup_game();
  }
  
  scroll_up(false);
  
  int offset = random(3)-1;
  bottomItemX=bottomItemX+offset;
  bottomItemX = constrain(bottomItemX,gameMinX,(gameMaxX-bottomItemWidth));
  for (int i=gameMinX;i<bottomItemX;i++) {
    setPixel(i,gameMinY,random(7)+1);
  }
  for (int i=(bottomItemX+bottomItemWidth+1);i<=gameMaxX;i++) {
    setPixel(i,gameMinY,random(7)+1);
  }
  setPixel(bottomItemX,gameMinY,7);
  setPixel(bottomItemX+bottomItemWidth,gameMinY,7);

  setPixel(carX,gameMaxY-1,7);
  refresh_display(carSpeed-speedOffset);
  distance++;
  if ((distance % 25) == 0) {
    points=distance/25;
    update_scorebar();
    if ((points % 25) == 0 ){
      level++;
      bottomItemWidth--;
    }
  }

}

void race_setup_game()
{
  clear_display();
  bottomItemWidth=10;
  bottomItemX=gameCentreX-(bottomItemWidth/2);
  carX=gameCentreX;
  carSpeed=10;
  points=0;
  distance=0;
  level=1;
  speedOffset=0;
  oldOffset=99;
}

